// CHECKSTYLE:OFF
/**
 * Source code generated by Fluent Builders Generator
 * Do not modify this file
 * See generator home page at: http://code.google.com/p/fluent-builders-generator-eclipse-plugin/
 */

package nl.krocket.ocr.core.model.builders;

import java.util.HashSet;
import java.util.Set;
import nl.krocket.ocr.core.model.Address;
import nl.krocket.ocr.core.model.Company;

public class AddressBuilder extends AddressBuilderBase<AddressBuilder> {
	public static AddressBuilder address() {
		return new AddressBuilder();
	}

	public AddressBuilder() {
		super(new Address());
	}

	public Address build() {
		return getInstance();
	}
}

class AddressBuilderBase<GeneratorT extends AddressBuilderBase<GeneratorT>> {
	private Address instance;

	protected AddressBuilderBase(Address aInstance) {
		instance = aInstance;
	}

	protected Address getInstance() {
		return instance;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withAddressId(Long aValue) {
		instance.setAddressId(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withStreetName(String aValue) {
		instance.setStreetName(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withHouseNr(String aValue) {
		instance.setHouseNr(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withPostcode(String aValue) {
		instance.setPostcode(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withCity(String aValue) {
		instance.setCity(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withCountryCode(String aValue) {
		instance.setCountryCode(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withAccepted(boolean aValue) {
		instance.setAccepted(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withCompany(Company aValue) {
		instance.setCompany(aValue);

		return (GeneratorT) this;
	}

	public CompanyCompanyBuilder withCompany() {
		Company obj = new Company();

		withCompany(obj);

		return new CompanyCompanyBuilder(obj);
	}

	public class CompanyCompanyBuilder extends
			CompanyBuilderBase<CompanyCompanyBuilder> {
		public CompanyCompanyBuilder(Company aInstance) {
			super(aInstance);
		}

		@SuppressWarnings("unchecked")
		public GeneratorT endCompany() {
			return (GeneratorT) AddressBuilderBase.this;
		}
	}

	public static class CompanyBuilderBase<GeneratorT extends CompanyBuilderBase<GeneratorT>> {
		private Company instance;

		protected CompanyBuilderBase(Company aInstance) {
			instance = aInstance;
		}

		protected Company getInstance() {
			return instance;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withCompanyId(Long aValue) {
			instance.setCompanyId(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withCompanyName(String aValue) {
			instance.setCompanyName(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withAddressSet(Set<Address> aValue) {
			instance.setAddressSet(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withAddedAddressSetElement(Address aValue) {
			if (instance.getAddressSet() == null) {
				instance.setAddressSet(new HashSet<Address>());
			}

			((HashSet<Address>) instance.getAddressSet()).add(aValue);

			return (GeneratorT) this;
		}

		public AddedAddressSetElementAddressBuilder withAddedAddressSetElement() {
			Address obj = new Address();

			withAddedAddressSetElement(obj);

			return new AddedAddressSetElementAddressBuilder(obj);
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withAccepted(boolean aValue) {
			instance.setAccepted(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withVatNumber(String aValue) {
			instance.setVatNumber(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withKvkNumber(String aValue) {
			instance.setKvkNumber(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withUrl(String aValue) {
			instance.setUrl(aValue);

			return (GeneratorT) this;
		}

		public class AddedAddressSetElementAddressBuilder extends
				AddressBuilderBase<AddedAddressSetElementAddressBuilder> {
			public AddedAddressSetElementAddressBuilder(Address aInstance) {
				super(aInstance);
			}

			@SuppressWarnings("unchecked")
			public GeneratorT endAddressSetElement() {
				return (GeneratorT) CompanyBuilderBase.this;
			}
		}
	}
}
